package com.liang.dao;

import com.liang.entity.StaDeviceexpenses;
import org.apache.ibatis.annotations.Param;
import org.springframework.data.domain.Pageable;

import java.util.List;

/**
 * 仪器设备使用费(StaDeviceexpenses)表数据库访问层
 *
 * @author makejava
 * @since 2023-07-18 21:51:46
 */
public interface StaDeviceexpensesDao {

    /**
     * 通过ID查询单条数据
     *
     * @param id 主键
     * @return 实例对象
     */
    StaDeviceexpenses queryById(Integer id);

    /**
     * 查询指定行数据
     *
     * @param staDeviceexpenses 查询条件
     * @param pageable          分页对象
     * @return 对象列表
     */
    List<StaDeviceexpenses> queryAllByLimit(StaDeviceexpenses staDeviceexpenses, @Param("pageable") Pageable pageable);

    /**
     * 统计总行数
     *
     * @param staDeviceexpenses 查询条件
     * @return 总行数
     */
    long count(StaDeviceexpenses staDeviceexpenses);

    /**
     * 新增数据
     *
     * @param staDeviceexpenses 实例对象
     * @return 影响行数
     */
    int insert(StaDeviceexpenses staDeviceexpenses);

    /**
     * 批量新增数据（MyBatis原生foreach方法）
     *
     * @param entities List<StaDeviceexpenses> 实例对象列表
     * @return 影响行数
     */
    int insertBatch(@Param("entities") List<StaDeviceexpenses> entities);

    /**
     * 批量新增或按主键更新数据（MyBatis原生foreach方法）
     *
     * @param entities List<StaDeviceexpenses> 实例对象列表
     * @return 影响行数
     * @throws org.springframework.jdbc.BadSqlGrammarException 入参是空List的时候会抛SQL语句错误的异常，请自行校验入参
     */
    int insertOrUpdateBatch(@Param("entities") List<StaDeviceexpenses> entities);

    /**
     * 修改数据
     *
     * @param staDeviceexpenses 实例对象
     * @return 影响行数
     */
    int update(StaDeviceexpenses staDeviceexpenses);

    /**
     * 通过主键删除数据
     *
     * @param id 主键
     * @return 影响行数
     */
    int deleteById(Integer id);

    /**
     * 获取仪器设备使用费列表
     *
     * @return
     */
    List<StaDeviceexpenses> getSbsyfList(Integer zb);

    /**
     * 通过主表删除数据
     *
     * @param zb
     * @return
     */
    int deleteByZb(Integer zb);

    /**
     * 批量删除仪器设备使用费
     *
     * @param zbList
     * @return
     */
    int batchDeleteByZb(List<Integer> zbList);
}

